#pragma once

#ifndef RECONQUE_H_
#define RECONQUE_H_

/* SPDX-License-Identifier: 0BSD */

#ifndef RCQ_MALLOC
#define RCQ_MALLOC(n) (malloc(n))
#endif
#ifndef RCQ_FREE
#define RCQ_FREE(p) (free(p))
#endif

struct reconque;

struct reconque *
rcq_alloc(size_t slots);

struct reconque *
rcq_recon(size_t slots, struct reconque *old);

void
rcq_free(struct reconque *queue);

int
rcq_push(struct reconque *queue, void *item);

void *
rcq_pop(struct reconque *queue);

#endif
